package com.hfkj.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsDiscountPkStockBatchExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsDiscountPkStockBatchExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdIsNull() {
            addCriterion("discount_pk_id is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdIsNotNull() {
            addCriterion("discount_pk_id is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdEqualTo(Long value) {
            addCriterion("discount_pk_id =", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdNotEqualTo(Long value) {
            addCriterion("discount_pk_id <>", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdGreaterThan(Long value) {
            addCriterion("discount_pk_id >", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdGreaterThanOrEqualTo(Long value) {
            addCriterion("discount_pk_id >=", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdLessThan(Long value) {
            addCriterion("discount_pk_id <", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdLessThanOrEqualTo(Long value) {
            addCriterion("discount_pk_id <=", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdIn(List<Long> values) {
            addCriterion("discount_pk_id in", values, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdNotIn(List<Long> values) {
            addCriterion("discount_pk_id not in", values, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdBetween(Long value1, Long value2) {
            addCriterion("discount_pk_id between", value1, value2, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdNotBetween(Long value1, Long value2) {
            addCriterion("discount_pk_id not between", value1, value2, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoIsNull() {
            addCriterion("discount_pk_no is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoIsNotNull() {
            addCriterion("discount_pk_no is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoEqualTo(String value) {
            addCriterion("discount_pk_no =", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoNotEqualTo(String value) {
            addCriterion("discount_pk_no <>", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoGreaterThan(String value) {
            addCriterion("discount_pk_no >", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoGreaterThanOrEqualTo(String value) {
            addCriterion("discount_pk_no >=", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoLessThan(String value) {
            addCriterion("discount_pk_no <", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoLessThanOrEqualTo(String value) {
            addCriterion("discount_pk_no <=", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoLike(String value) {
            addCriterion("discount_pk_no like", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoNotLike(String value) {
            addCriterion("discount_pk_no not like", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoIn(List<String> values) {
            addCriterion("discount_pk_no in", values, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoNotIn(List<String> values) {
            addCriterion("discount_pk_no not in", values, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoBetween(String value1, String value2) {
            addCriterion("discount_pk_no between", value1, value2, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoNotBetween(String value1, String value2) {
            addCriterion("discount_pk_no not between", value1, value2, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameIsNull() {
            addCriterion("discount_pk_name is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameIsNotNull() {
            addCriterion("discount_pk_name is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameEqualTo(String value) {
            addCriterion("discount_pk_name =", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameNotEqualTo(String value) {
            addCriterion("discount_pk_name <>", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameGreaterThan(String value) {
            addCriterion("discount_pk_name >", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameGreaterThanOrEqualTo(String value) {
            addCriterion("discount_pk_name >=", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameLessThan(String value) {
            addCriterion("discount_pk_name <", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameLessThanOrEqualTo(String value) {
            addCriterion("discount_pk_name <=", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameLike(String value) {
            addCriterion("discount_pk_name like", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameNotLike(String value) {
            addCriterion("discount_pk_name not like", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameIn(List<String> values) {
            addCriterion("discount_pk_name in", values, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameNotIn(List<String> values) {
            addCriterion("discount_pk_name not in", values, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameBetween(String value1, String value2) {
            addCriterion("discount_pk_name between", value1, value2, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameNotBetween(String value1, String value2) {
            addCriterion("discount_pk_name not between", value1, value2, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andBatchNoIsNull() {
            addCriterion("batch_no is null");
            return (Criteria) this;
        }

        public Criteria andBatchNoIsNotNull() {
            addCriterion("batch_no is not null");
            return (Criteria) this;
        }

        public Criteria andBatchNoEqualTo(String value) {
            addCriterion("batch_no =", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoNotEqualTo(String value) {
            addCriterion("batch_no <>", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoGreaterThan(String value) {
            addCriterion("batch_no >", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoGreaterThanOrEqualTo(String value) {
            addCriterion("batch_no >=", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoLessThan(String value) {
            addCriterion("batch_no <", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoLessThanOrEqualTo(String value) {
            addCriterion("batch_no <=", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoLike(String value) {
            addCriterion("batch_no like", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoNotLike(String value) {
            addCriterion("batch_no not like", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoIn(List<String> values) {
            addCriterion("batch_no in", values, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoNotIn(List<String> values) {
            addCriterion("batch_no not in", values, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoBetween(String value1, String value2) {
            addCriterion("batch_no between", value1, value2, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoNotBetween(String value1, String value2) {
            addCriterion("batch_no not between", value1, value2, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumIsNull() {
            addCriterion("batch_stock_num is null");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumIsNotNull() {
            addCriterion("batch_stock_num is not null");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumEqualTo(Integer value) {
            addCriterion("batch_stock_num =", value, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumNotEqualTo(Integer value) {
            addCriterion("batch_stock_num <>", value, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumGreaterThan(Integer value) {
            addCriterion("batch_stock_num >", value, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("batch_stock_num >=", value, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumLessThan(Integer value) {
            addCriterion("batch_stock_num <", value, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumLessThanOrEqualTo(Integer value) {
            addCriterion("batch_stock_num <=", value, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumIn(List<Integer> values) {
            addCriterion("batch_stock_num in", values, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumNotIn(List<Integer> values) {
            addCriterion("batch_stock_num not in", values, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumBetween(Integer value1, Integer value2) {
            addCriterion("batch_stock_num between", value1, value2, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andBatchStockNumNotBetween(Integer value1, Integer value2) {
            addCriterion("batch_stock_num not between", value1, value2, "batchStockNum");
            return (Criteria) this;
        }

        public Criteria andStartIdIsNull() {
            addCriterion("start_id is null");
            return (Criteria) this;
        }

        public Criteria andStartIdIsNotNull() {
            addCriterion("start_id is not null");
            return (Criteria) this;
        }

        public Criteria andStartIdEqualTo(String value) {
            addCriterion("start_id =", value, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdNotEqualTo(String value) {
            addCriterion("start_id <>", value, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdGreaterThan(String value) {
            addCriterion("start_id >", value, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdGreaterThanOrEqualTo(String value) {
            addCriterion("start_id >=", value, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdLessThan(String value) {
            addCriterion("start_id <", value, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdLessThanOrEqualTo(String value) {
            addCriterion("start_id <=", value, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdLike(String value) {
            addCriterion("start_id like", value, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdNotLike(String value) {
            addCriterion("start_id not like", value, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdIn(List<String> values) {
            addCriterion("start_id in", values, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdNotIn(List<String> values) {
            addCriterion("start_id not in", values, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdBetween(String value1, String value2) {
            addCriterion("start_id between", value1, value2, "startId");
            return (Criteria) this;
        }

        public Criteria andStartIdNotBetween(String value1, String value2) {
            addCriterion("start_id not between", value1, value2, "startId");
            return (Criteria) this;
        }

        public Criteria andEndIdIsNull() {
            addCriterion("end_id is null");
            return (Criteria) this;
        }

        public Criteria andEndIdIsNotNull() {
            addCriterion("end_id is not null");
            return (Criteria) this;
        }

        public Criteria andEndIdEqualTo(String value) {
            addCriterion("end_id =", value, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdNotEqualTo(String value) {
            addCriterion("end_id <>", value, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdGreaterThan(String value) {
            addCriterion("end_id >", value, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdGreaterThanOrEqualTo(String value) {
            addCriterion("end_id >=", value, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdLessThan(String value) {
            addCriterion("end_id <", value, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdLessThanOrEqualTo(String value) {
            addCriterion("end_id <=", value, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdLike(String value) {
            addCriterion("end_id like", value, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdNotLike(String value) {
            addCriterion("end_id not like", value, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdIn(List<String> values) {
            addCriterion("end_id in", values, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdNotIn(List<String> values) {
            addCriterion("end_id not in", values, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdBetween(String value1, String value2) {
            addCriterion("end_id between", value1, value2, "endId");
            return (Criteria) this;
        }

        public Criteria andEndIdNotBetween(String value1, String value2) {
            addCriterion("end_id not between", value1, value2, "endId");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}